
-- ͻ
--        D E S I G N   E N G I N E R I N G              DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         Package     Os2.dlg                                        
--                                                                    
--         Author :  Leonid Dulman     1997                           
--                                                                    
--              GNU ADA RUNTIME LIBRARY (GNARL) COMPONENTS            
--                                                                    
--              OS/2 Presentation Manager  Page Controls              
--                                                                    
-- ͼ


package Os2.pmwp is
pragma Preelaborate (pmwp);


subtype HOBJECT is LHANDLE ;

--         Standard object classes

 CCHMAXCLASS  :constant Ulong :=   3 ;    -- Length of a classname

 QC_First     :constant Ulong :=   0 ;    -- Codes for OA_QueryContent
 QC_Next      :constant Ulong :=   1 ;
 QC_Last      :constant Ulong :=   2 ;

--         An object's appearance (icon or bitmap or outline)
subtype HPOINTER is PVOID;
type  OBJECTIMAGE is record    -- oimg
  hptrObject:HPOINTER ;
end record; --  OBJECTIMAGE;
type POBJECTIMAGE is access all OBJECTIMAGE;

--  Class info structure returned by WinEnumObjectClasses
type  OBJCLASS ;
type  POBJCLASS is access all OBJCLASS;
type  OBJCLASS is record  -- ocls
 pNext       :  POBJCLASS  ;  -- Null for the last structure..
 pszClassName:  PSZ        ;  -- Class name
 pszModName  :  PSZ        ;  -- Module name
end record; --  OBJCLASS;


-- Workplace object management functions

function WinRegisterObjectClass(pszClassName:PSZ ;
                                pszModName  :PSZ ) return BOOL ;
pragma Import(c,WinRegisterObjectClass, Link_name=>"_WinRegisterObjectClass");

function WinDeregisterObjectClass(pszClassName:PSZ ) return BOOL ;
pragma Import(c,WinDeregisterObjectClass, Link_name=>"_WinDeregisterObjectClass");

function WinReplaceObjectClass(pszOldClassName:PSZ ;
                               pszNewClassName:PSZ ;
                                fReplace      :BOOL) return  BOOL ;
pragma Import(c,WinReplaceObjectClass, Link_name=>"_WinReplaceObjectClass");

function WinEnumObjectClasses(p_ObjClass:POBJCLASS ;
                              pulSize  :PULONG    ) return  BOOL ;
pragma Import(c,WinEnumObjectClasses, Link_name=>"_WinEnumObjectClasses");

function WinCreateObject(pszClassName  :PSZ   ;
                         pszTitle      :PSZ   ;
                         pszSetupString:PSZ   ;
                         pszLocation   :PSZ   ;
                         ulFlags       :ULONG ) return  HOBJECT ;
pragma Import(c,WinCreateObject, Link_name=>"_WinCreateObject");

CO_FAILIFEXISTS      :constant Ulong :=  0 ;
CO_REPLACEIFEXISTS   :constant Ulong :=  1 ;
CO_UPDATEIFEXISTS    :constant Ulong :=  2 ;

function WinSetObjectData(h_Object      :HOBJECT ;
                          pszSetupString:PSZ     ) return  BOOL ;
pragma Import(c,WinSetObjectData, Link_name=>"_WinSetObjectData");

function WinDestroyObject(h_Object:HOBJECT ) return  BOOL ;
pragma Import(c,WinDestroyObject, Link_name=>"_WinDestroyObject");

function WinQueryObject(pszObjectID:PSZ ) return HOBJECT ;
pragma Import(c,WinQueryObject, Link_name=>"_WinQueryObject");

--      Object settings notebook page insertion structure

type  PAGEINFO is record    -- pginf
 cb                :  ULONG   ;
 hwndPage          :  HWND    ;
 p_fnwp            :  PFNWP   ;
 resid             :  ULONG   ;
 pCreateParams     :  PVOID   ;
 dlgid             :  USHORT  ;
 usPageStyleFlags  :  USHORT  ;
 usPageInsertFlags :  USHORT  ;
 usSettingsFlags   :  USHORT  ;
 pszName           :  PSZ     ;
 idDefaultHelpPanel:  USHORT  ;
 usReserved2       :  USHORT  ;
 pszHelpLibraryName:  PSZ     ;
 pHelpSubtable     :  PUSHORT ; -- PHELPSUBTABLE when PMHELP.H is included
 hmodHelpSubtable  :  HMODULE ;
 ulPageInsertId    :  ULONG   ;
end record; --  PAGEINFO;
type PPAGEINFO is access all PAGEINFO;

SETTINGS_PAGE_NUMBERS :constant Ulong :=  1;

-- Utility apis

type  ICONPOS is record    -- icp
 ptlIcon   :  POINTL       ;              -- Location
 szIdentity:  CHARACTER    ;              -- Object identity string
end record; --  ICONPOS;
type PICONPOS is access all ICONPOS;

function WinSetFileIcon(pszFileName:PSZ       ;
                        pIcnInfo   :PICONINFO ) return BOOL ;
pragma Import(c,WinSetFileIcon, Link_name=>"_WinSetFileIcon");

function WinFreeFileIcon(hptr:HPOINTER ) return BOOL ;
pragma Import(c,WinFreeFileIcon, Link_name=>"_WinFreeFileIcon");

function WinLoadFileIcon(pszFileName:PSZ  ;
                         fPrivate   :BOOL ) return HPOINTER ;
pragma Import(c,WinLoadFileIcon, Link_name=>"_WinLoadFileIcon");

function WinStoreWindowPos(pszAppName:PSZ ;
                           pszKeyName:PSZ ;
                           h_wnd     :HWND) return BOOL ;
pragma Import(c,WinStoreWindowPos, Link_name=>"_WinStoreWindowPos");

function WinRestoreWindowPos(pszAppName:PSZ  ;
                             pszKeyName:PSZ  ;
                             h_wnd     :HWND ) return  BOOL ;
pragma Import(c,WinRestoreWindowPos, Link_name=>"_WinRestoreWindowPos");

function WinShutdownSystem(h_ab:HAB ;
                           h_mq:HMQ ) return  BOOL ;
pragma Import(c,WinShutdownSystem, Link_name=>"_WinShutdownSystem");

end Os2.pmwp ;
